#include <iostream>
#include <windows.h>
#include "usbhid.h"
#include <conio.h>
using namespace std;


#pragma comment( lib, "setupapi.lib")
//#pragma comment( lib, "hid.lib")

// HID API (from w2k DDK)
_HidD_GetAttributes HidD_GetAttributes;
_HidD_GetHidGuid HidD_GetHidGuid;
_HidD_GetPreparsedData HidD_GetPreparsedData;
_HidD_FreePreparsedData HidD_FreePreparsedData;
_HidP_GetCaps HidP_GetCaps;
_HidP_GetValueCaps HidP_GetValueCaps;

HINSTANCE hHID_DLL=NULL; // hid.dll handle
HANDLE hHID=NULL; // USB-IO dev handle
HIDP_CAPS Caps;


////////////////////////////////////////////////////////////////////////
//             hid.dll [h
static int LoadHidDLL(){
	hHID_DLL=LoadLibrary("hid.dll");
	if(!hHID_DLL){
		cerr << "Error at Load 'hid.dll'" << endl;
		return 0;
	}
	HidD_GetAttributes
		=(_HidD_GetAttributes)GetProcAddress(hHID_DLL,"HidD_GetAttributes");
	if(!HidD_GetAttributes){
		cerr << "Error at HidD_GetAttributes" << endl;
		return 0;
	}
	HidD_GetHidGuid
		=(_HidD_GetHidGuid)GetProcAddress(hHID_DLL,"HidD_GetHidGuid");
	if(!HidD_GetHidGuid){
		cerr << "Error at HidD_GetHidGuid" << endl;
		return 0;
	}
	HidD_GetPreparsedData
		=(_HidD_GetPreparsedData)GetProcAddress(hHID_DLL,"HidD_GetPreparsedData");
	HidD_FreePreparsedData
		=(_HidD_FreePreparsedData)GetProcAddress(hHID_DLL,"HidD_FreePreparsedData");
	HidP_GetCaps
		=(_HidP_GetCaps)GetProcAddress(hHID_DLL,"HidP_GetCaps");
	HidP_GetValueCaps
		=(_HidP_GetValueCaps)GetProcAddress(hHID_DLL,"HidP_GetValueCaps");
	return 1;
}

////////////////////////////////////////////////////////////////////////
// fBoCX̏擾
static void GetDevCaps(){
	PHIDP_PREPARSED_DATA PreparsedData;
	HIDP_VALUE_CAPS* VCaps;
	char buf[1024];
	VCaps=(HIDP_VALUE_CAPS*)(&buf);

	HidD_GetPreparsedData(hHID,&PreparsedData);
	HidP_GetCaps(PreparsedData,&Caps);
	HidP_GetValueCaps(HidP_Input,VCaps,
		&Caps.NumberInputValueCaps,
		PreparsedData);
	HidD_FreePreparsedData(PreparsedData);
}

////////////////////////////////////////////////////////////////////////
// HIDfBoCXꗗUSBIO
static int OpenTheHid(){
	int f=0;
	int i=0;
	ULONG Needed,l;
	GUID HidGuid;
	HDEVINFO DeviceInfoSet;
	HIDD_ATTRIBUTES DeviceAttributes;
	SP_DEVICE_INTERFACE_DATA DevData;
	PSP_INTERFACE_DEVICE_DETAIL_DATA DevDetail;
	//SP_DEVICE_INTERFACE_DETAIL_DATA *MyDeviceInterfaceDetailData;

	DeviceAttributes.Size=sizeof(HIDD_ATTRIBUTES);
	DevData.cbSize=sizeof(SP_DEVICE_INTERFACE_DATA);

//	printf("OpenTheHid()\n");
	HidD_GetHidGuid(&HidGuid);
//	printf("%x-%x-%x-%x %x %x %x %x %x %x %x",HidGuid.Data1,HidGuid.Data2,HidGuid.Data3,
//		HidGuid.Data4[0],HidGuid.Data4[1],HidGuid.Data4[2],HidGuid.Data4[3],
//		HidGuid.Data4[4],HidGuid.Data4[5],HidGuid.Data4[6],HidGuid.Data4[7]);
	DeviceInfoSet=SetupDiGetClassDevs(&HidGuid,NULL,
		NULL,DIGCF_PRESENT | DIGCF_DEVICEINTERFACE);

	while(SetupDiEnumDeviceInterfaces(DeviceInfoSet,0,&HidGuid,i++,&DevData)){
		SetupDiGetDeviceInterfaceDetail(DeviceInfoSet,&DevData,
			NULL,0,&Needed,0);
		l=Needed;
		DevDetail=(SP_DEVICE_INTERFACE_DETAIL_DATA*)GlobalAlloc(GPTR,l+4);
		DevDetail->cbSize=sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
		SetupDiGetDeviceInterfaceDetail(DeviceInfoSet,&DevData,
			DevDetail,l,&Needed,0);

		//printf("Path: %s\n",DevDetail->DevicePath);
		hHID = CreateFile(
			DevDetail->DevicePath,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,OPEN_EXISTING,FILE_FLAG_WRITE_THROUGH | FILE_FLAG_NO_BUFFERING,NULL);
		GlobalFree(DevDetail);
		if(hHID==INVALID_HANDLE_VALUE) // Can't open a device
			continue;
		HidD_GetAttributes(hHID,&DeviceAttributes);
		// USB-IOǂׂ
		if (DeviceAttributes.VendorID==5824
			&& DeviceAttributes.ProductID==1500) {
				f=1;
				break;
		}else{
			// 
			CloseHandle(hHID);
			hHID=NULL;
		}
	}
	SetupDiDestroyDeviceInfoList(DeviceInfoSet);
	return f;
}


#define HIDASP_TEST 1
#define HIDASP_SET_STATUS 2
#define HIDASP_CMD_TX 16
#define HIDASP_SET_PAGE 20
#define HIDASP_PAGE_TX 22
#define HIDASP_SET_DELAY 60

int hidasp_cmd(const unsigned char cmd[4],unsigned char res[4])
{
	ULONG sz=0;
	char buf[16];
	buf[0]=0;
	buf[1]=res?(HIDASP_CMD_TX+1):(HIDASP_CMD_TX);

	memcpy(buf+2,cmd,4);
	WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
//	printf("hidasp_cmd %d cmd: %02x %02x %02x %02x\n",buf[1],cmd[0],cmd[1],cmd[2],cmd[3]);

	if (res) {
		ReadFile(hHID,buf,Caps.InputReportByteLength,&sz,NULL);
		memcpy(res,buf+1,4);
//		printf("          res: %02x %02x %02x %02x\n",res[0],res[1],res[2],res[3]);
	}

	return 1;
}

int hidasp_init()
{
	ULONG sz;
	unsigned char buf[16]={0,0,0,0,};
	unsigned char chkdata[]={0x00,0xff,0x5a};
	int i;

	printf("hidasp_init()... ");

	LoadHidDLL();
	if (!OpenTheHid()){
		printf("ERROR: fail to OpenTheHid()\n");
		return 1;
	}
	GetDevCaps();

	Sleep(50);
//	ReadFile(hHID,buf,Caps.InputReportByteLength,&sz,NULL);
//exit(0);


	// ŏ̃pPbg肱ڂ̂Ń_~[f[^𑗂
	buf[0]=0;
	buf[1]=HIDASP_TEST;
	buf[2]=0x11;
	WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
	Sleep(10);

	// 2008-09-20 Win2k͓͂obt@OĂȂ悤Ȃ̂ŏC
	for (i=0;i<sizeof(chkdata);i++) {
		buf[0]=0;
		buf[1]=HIDASP_TEST;
		buf[2]=chkdata[i];
		WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
		Sleep(1);
		while(1) {
			if(!ReadFile(hHID,buf,Caps.InputReportByteLength,&sz,NULL)) {
				printf("ERR. fail to Read().\n");
				return 1;
			}
			if (buf[1]==chkdata[i]) break;
			Sleep(1);
		}
	}

	printf("OK.\n");

	return 0;
}

void hidasp_close() {
	if (hHID) {
		ULONG sz;
		unsigned char buf[128];
		buf[0]=0x00; buf[1]=0x00; buf[2]=0x00; buf[3]=0x00;
		hidasp_cmd(buf,NULL); // AVOID BUG!
		buf[0]=0;
		buf[1]=HIDASP_SET_STATUS;
		buf[2]=2; // LED
		buf[3]=0x10; // RESET HI
		WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
		CloseHandle(hHID);
	}
	if (hHID_DLL) FreeLibrary(hHID_DLL);
	hHID=NULL;
	hHID_DLL=NULL;
}


int hidasp_program_enable(int delay)
{
	unsigned char buf[128];
	unsigned char res[4];
	ULONG sz;

	buf[0]=0;
	buf[1]=60; // SET_DELAY
	buf[2]=delay;
	buf[3]=0x00;
	WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);

	buf[1]=HIDASP_SET_STATUS;
	buf[2]=0x02; // LED
	buf[3]=0x10; // RESET HIGH
	WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
	Sleep(1);

	buf[1]=HIDASP_SET_STATUS;
	buf[2]=0x00; // LED
	buf[3]=0x00; // RESET LOW
	WriteFile(hHID,buf,Caps.OutputReportByteLength,&sz,NULL);
	Sleep(1);

	return 0;
}



int main(){

	hidasp_init();

	hidasp_program_enable(100);

	for (;;) {
		unsigned char buf[16];
		buf[0]=0x00;
		buf[1]=0x00;
		buf[2]=0x00;
		buf[3]=0x00;
		if (kbhit()) buf[0]=getch();
		hidasp_cmd(buf,buf);
		for(int i=0;i<4;i++)
			if (buf[i]) cout << buf[i];
		//cout << buf[0] << buf[1] << buf[2] << buf[3];
		Sleep(10);
	}

	return 0;
}

